## fwts 16.09.00

=== debian/changelog ===
fwts (16.09.00-0ubuntu4.1) yakkety; urgency=low

  * fix segment fault when running fwts method test (LP: #1635502)
    - remove double pthread_mutex_unlock on method usage thread counter

 -- Colin King <colin.king@canonical.com>  Fri, 21 Oct 2016 09:27:32 +0100

fwts (16.09.00-0ubuntu4) yakkety; urgency=low

  * Makefile.am: include exconcat.c into libfwtsiasl build (LP: #1631354)
    - fixes uninitialized aliased AcpiGbl_OperandCache from libfwtsacpica
      causing AE_NO_MEMORY while evaluating a constant string expression
      because cache was null.

 -- Colin King <colin.king@canonical.com>  Fri, 7 Oct 2016 13:51:31 +0100

fwts (16.09.00-0ubuntu3) yakkety; urgency=low

  [Colin Ian King]
  * debian/control: fwts-efi-runtime-dkms should not depend on
    kernel headers (LP: #1629826)

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 05 Oct 2016 12:01:47 +0100

fwts (16.09.00-0ubuntu2) yakkety; urgency=medium

  * Build using dpkg-dev's hardening support.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 05 Oct 2016 05:33:08 +0200

fwts (16.09.00-0ubuntu1) yakkety; urgency=low

  [Alex Hung]
  * lib: acpi: add supports for WPBT
  * acpi: wpbt: add ACPI WPBT test
  * fwts-test: Add regression test for WPBT
  * lib: acpi: add supports for DRTM
  * acpi: drtm: add ACPI DRTM test
  * fwts-test: Add regression test for DRTM
  * acpi: remove "Linux-ready Firmware Developer Kit" from license header
  * lib: fwts_guid: add a compare function
  * acpi: nfit: skip SPA Range Structure Index for four GUIDs
  * acpi: nfit: check fields equals 0 for Virtual CD and Disk
  * cpu: msr: change SMRR_PHYSBASE from 8MB boundary to 4KB boundary

  [Colin Ian King]
  * acpica: remove utprint.c, it is not required
  * ACPICA: Remove utfileio.c, it is deprecated and not used
  * ACPICA: Update to version 20160831
  * opal: ensure fdt_node_path buffer is null terminated
  * fwts: treewide: voidify return from close(), closedir() and fclose()
  * lib: fwts_ipmi: fix incorrect memset size

  [Deb McLemore]
  * opal: mtd: Add OPAL MTD Validation
  * acpi: ACPI Platform check updates
  * opal: mtd: Add error exit when no MTD's
  * opal: prd: Improve message when no PRD detected
  * devicetree: dt_sysinfo: Improve message for non-reference model

  [Ivan Hu]
  * efi_runtime: change __usc2_strsize name to distinguish from ucs2_strsize
  * efi_runtime: redefine all uint*_t types by following the header efi.h
  * efi_runtime: exchange the user and local name define
  * efi_runtime: refactor the success and error path
  * efi_runtime: add label to reduce the number of kfree
  * efi_runtime: expand to a full if-conditional instead of using terneary
    operator
  * efi_runtime: add VariableNameSize return when getting the
    EFI_BUFFER_TOO_SMALL
  * efi_runtime: fix memory leak of getvariable funtion
  * efi_runtime: move the checking status forward
  * efi_runtime: clean up some return and alignment code
  * uefirttime: specify enable to true for setwakeuptime wiht null time test

  [Jeffrey Hugo]
  * acpi: fadt: Remove HEADLESS check on reduced hardware
  * pci: aspm: Add segment support
 
 -- Alex Hung <alex.hung@ubuntu.com>  Fri, 09 Sep 2016 09:47:45 +0800

fwts (16.08.01-0ubuntu1) yakkety; urgency=low

  [Colin Ian King]
  * acpica: rename vsnprintf and sprintf in utprint.c to avoid name clash
    conflicts
 
 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 18 Aug 2016 17:46:32 +0800

fwts (16.08.00-0ubuntu1) yakkety; urgency=low

  [Alex Hung]
  * fwts: update .gitignore for files genereated by "make check"
  * acpi: nfit: add ACPI NFIT test
  * fwts-test: Add regression test for NFIT
  * acpi: pcct: fix incorrect printing length for PRIx64
  * lib: acpi: add support for MPST
  * acpi: mpst: add ACPI MPST test
  * fwts-test: Add regression test for MPST
  * lib: acpi: add support for PMTT
  * acpi: pmtt: add ACPI PMTT test
  * fwts-test: Add regression test for PMTT
  * acpi: nfit: change %x to marco PRIx32 for portability
  * auto-packager: mkpackage.sh: remove wily

  [Colin Ian King]
  * acpi: madt: fix memory leak on return paths
  * ACPICA: Update to version 20160729
  * acpi: pmtt: fix incorrect assignment on passed
  * acpi: dmar: fix portability warning from cppcheck on void * cast
  * acpi: dbg2: remove alloca(), replace with variable length array
  * acpi: madt: reduce scope of variable 'listint'
  * acpica: fwts_iasl_interface: reduce scope of variable 'i'
  * lib: fwts_smbios: reduce scope of variable 'mapped_entry'
  * lib: fwts_klog: reduce scope of variable 'old'
  * lib: fwts_iasl: reduce scope of variable 'ret'
  * lib: fwts_cpu: fix missing { } on an if statement
  * devicetree: dt_sysinfo: reduce scope of variables 'model_buf' and
    'compat_buf'
  * cpu: cpufreq: reduce scope of variable 'i'
  * lib: fwts_smbios: fix portability warning from cppcheck on void * cast
  * lib: fwts_alloc: fix portability warnings from cppcheck on void * arithmetic

  [Ivan Hu]
  * efi_runtime: call kfree directly instead of inline wrapper
  * efi_runtime: add datasize return when getting the EFI_BUFFER_TOO_SMALL
  * efi_runtime: fix memory leak of capsulecaps function
  * efi_runtime: clean up some comments and unused code
  * efi_runtime: add chceking the len for reading userspace memory
  * efi_runtime: add checking variable_name input

  [Prarit Bhargava]
  * acpi/nfit: Fix endless loop on broken NFIT tables

  [Ricardo Neri]
  * acpi: bert: do not fail if BERT error region raw_data_length is zero

 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 18 Aug 2016 12:14:11 +0800

fwts (16.07.00-0ubuntu1) yakkety; urgency=low

  [Alex Hung]
  * acpi: method: add _FIT test
  * fwts-test: sync up tests for _FIT method
  * bios: mtrr: check MTRR default memory type
  * acpi: pcct: add ACPI PCCT test
  * fwts-test: Add regression test for PCCT
  * lib: acpi: fix a typo in fwts_acpi.h

  [Colin Ian King]
  * utilities: kernelscan: Add in missing [ ] brackets tokenisation
  * klog: data.json: Add klog checking for kernel NUMA errors from


=== debian/control ===
Source: fwts
Section: devel
Priority: optional
Maintainer: Firmware Testing Team <fwts-devel@lists.ubuntu.com>
Uploaders: Colin King <colin.king@ubuntu.com>, Keng-Yu Lin <kengyu@ubuntu.com>, Alex Hung <alex.hung@canonical.com>, Ivan Hu <ivan.hu@canonical.com>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 7.0.50~), autoconf, automake, libtool, libjson0-dev | libjson-c-dev (>= 0.9), flex, bison, dh-autoreconf, dkms, libglib2.0-dev, pkg-config, libfdt-dev

Package: fwts
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
Depends: libfwtsiasl1 (= ${binary:Version}), libfwtsacpica1 (= ${binary:Version}), libfwts1 (= ${binary:Version}), fwts-efi-runtime-dkms (= ${binary:Version}) [amd64] , ${shlibs:Depends}, ${misc:Depends}, pciutils, device-tree-compiler [ppc64el powerpc]
Suggests: dmidecode
Description: FirmWare Test Suite
 This is a firmware test suite that performs sanity checks on Intel/AMD 
 PC firmware. It is intended to identify BIOS and ACPI errors and 
 if appropriate it will try to explain the errors and give advice to 
 help workaround or fix firmware bugs.  It is primarily intended to 
 be a Linux-centric firmware troubleshooting tool.

Package: libfwtsiasl1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for iasl functionality
 The firmware test suite requires the ACPICA core engine to be built in
 compiler mode (with ACPI_ASL_COMPILER enabled) to support assembly and 
 disassembly of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
 This library contains this code with a thin fwts specific API to 
 interface with fwts.

Package: libfwtsacpica1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for acpiexec functionality
 The firmware test suite requires the ACPICA core engine to be built in
 execution mode (with ACPI_EXEC_APP enabled) to support run time execution
 of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs. This library
 contains this code with a thin fwts specific API to interface with fwts.

Package: libfwts1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FirmWare Test Suite core support library
 This is the fwts core library. It contains a top level test framework
 and a rich range of firmware specific testing support code for the 
 various fwts tests.

Package: fwts-frontend
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, dialog, fwts
Description: Firmware Test Suite frontend interface
 This is a dialog based interface designed to provide an easy to use method
 to execute tests via Firmware Test Suite and is also used as the primary 
 interface within Firmware Test Suite live images.

Package: fwts-efi-runtime-dkms
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
Description: Firmware Test Suite UEFI Runtime Service kernel driver
 This package provides the efi_runtime kernel driver in DKMS format,
 which is required for accessing UEFI Runtime Services.

## fwts 17.03.00

=== Makefile ===
#
# Copyright (C) 2012-2017 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

KVER ?= `uname -r`
obj-m += efi_runtime.o
all:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules

install:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules_install

clean:
	make -C /lib/modules/$(KVER)/build M=`pwd` clean

=== debian/changelog ===
fwts (17.03.00-0ubuntu1) zesty; urgency=low

  [Alex Hung]
  * dmicheck: update chassis type limit according to SMBIOS 3.0
  * fwts-tests: sync up with the new --sbbr option
  * README: update url of reference guide
  * dmicheck: update type 3, 4, 9 limits according to SMBIOS spec 3.11

  [Colin Ian King]
  * lib: fwts_alloc: move all memory tracking to hash records
  * klog.json: Add some missing ACPI Power Management kernel messages to klog database
  * opal: reduce scope of variable 'prop_buf'
  * lib: fwts_alloc: clear hash table at end of garbage collection
  * lib: fwts_alloc: fix incorrect accounting on hash entry count
  * ACPICA: Update to version 20170224
  * fwts-test: disassemble-0001: sync DSDT output from iasl with recent ACPICA changes
  * acpi: mpst: remove redundant assigments to passed on errors
  * acpi: drtm: remove redundant assigments to passed on errors
  * opal: pci_info: remove redundant assignment to bytes
  * ACPICA: Update to version 20170303
  * lib: fwts_devicetree.h: minor code formatting cleanups
  * opal: make found_dimm static as it is local to just this source
  * opal: minor code style changes

  [Deb McLemore]
  * opal: mem_info check for dimm presence in property

  [Jeffrey Hugo]
  * acpi: acpiinfo: Print minor version where applicable
  * acpi: iort: Add support for SMMUv3

  [Supreeth Venkatesh]
  * sbbr: Add "--sbbr" flag to support running SBBR Tests.
 
 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 16 Mar 2017 11:20:20 +0800

fwts (17.02.00-0ubuntu1) zesty; urgency=low

  [Alex Hung]
  * dmicheck: fix mistakes in error messages for SMBIOS type 9

  [Colin Ian King]
  * ACPICA: Update to version 20170119
  * README: update git URL to http://kernel.ubuntu.com/git/hwe/fwts.git/
  * lib: fwts_args: fix arg parameter sanity range checking
  * fwts-test: update arg-help-0001 to sync with help info changes
  * fwts_framework: handle -? option differently from -h
  * uefi/uefirtvariable: fix options check error messages
  * acpi: s3: Add new --s3-resume-hook option
  * clean up missing whitespaces
  * acpi: acpitables: fix indentation, no functional change
  * devicetree: dt_sysinfo: reduce scope of version_buf
  * lib: fwts_acpid: remove re-assignment of ptr to NULL
  * lib: fwts_cpu: force compiler to increment i rather than optimize it out
  * opal: mem_info: remove redundant initialization of prop_string to NULL
  * opal: mem_info: reduce scope of some variables
  * opal: cpu_info: remove redundant initialization of prop_string to NULL
  * opal: cpu_info: reduce scope of some variables
  * opal: pci_info: reduce scope of some variables
  * doc: remove trailing white spaces
  * opal/mtd_info.c: make a couple of functions static to reduce global scope
  * uefi: uefirtmisc: make gEfiCapsuleHeaderGuid static
  * opal: prd_info: make a couple of functions static to reduce global scope
  * ipmi: bmc: make fwts_bmc_info_check static
  * acpi: msdm: make variable table static
  * acpi: slit: make variable table static
  * acpi: fpdt: make variable table static
  * acpi: slic: make variable table static
  * misc: fix various spelling mistakes
  * data: fix some spelling mistakes in klog and olog databases
  * fwts-tests: fix up spelling mistakes in regression tests
  * lib: fwts_olog: ensure buffer is null terminated
  * lib: fwts_pipeio: fix memory leak on zero sized text allocation
  * fwts-alloc: track memory allocations, cleans up 6 coverity scan warnings
  * fwts-alloc: garbage collect hash records
  * klog.json: Add some more kernel messages to klog data base
  * klog.json: Add some EFI driver kernel messages to klog database
  * klog.json: Add some EFI quirk driver kernel messages to klog database
  * klog.json: Add some more EFI driver kernel messages to klog database
  * klog.json: Add some miscellaneous messages to klog database
  * klog.json: fix a couple of klog patterns

  [Deb McLemore]
  * Add README_JSON.txt for FWTS
  * Integrate PPC for FWTS-LIVE Frontend

  [Prarit Bhargava]
  * fedora: Fix location of klog.json file in fwts.spec
  * fedora: Add fedora internal versioning number in fwts.spec
  * fedora: Add fwts.spec.in
  * fedora: Update buildsrpm.sh for dynamic versioning

 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 16 Feb 2017 09:58:33 +0800

fwts (17.01.00-0ubuntu1) zesty; urgency=low

  [Colin Ian King]
  * ACPICA: Update to version 20161222
  * opal: pci_info: minor code style clean-ups, no functional changes
  * update copyright year to 2017
  * fwts-test/arg-help-0001: update log files to match copyright year changes
  * klog.json: Add kernel errors to the database

  [Prarit Bhargava]
  * fedora/fwts.spec: Add initial version of fwts.spec
  * fedora/buildrpm.sh: Add build script for RPMs
  * .gitignore: update with fedora/rpm and git generated patches
  * .gitignore: Add aslcompiler.y

 -- Alex Hung <alex.hung@ubuntu.com>  Thu, 19 Jan 2017 12:19:10 +0800

fwts (16.12.00-0ubuntu1) zesty; urgency=low

  [Colin Ian King]
  * ACPICA: Update to version 20161117
  * fwts-test: sync up disassemble and syntaxcheck tests with ACPICA
  * acpica: s390x needs to be built as a 64 bit architecture
  * klog.json: Add a few more kernel errors to the database
  * klog.json: Update the klog database with more kernel patterns

  [Deb McLemore]
  * opal: pci_info: Add OPAL PCI Info validation
  * opal: mem_info: Add OPAL MEM Info validation
  * opal: cpu_info: Add OPAL CPU Info validation
  * devicetree: dt_sysinfo: Add OPAL firmware version checks
  * olog: olog.json: Update OPAL skiboot errors to check on olog scan

  [Fan Wu]
  * fwts:dmicheck: replace memcpy with fwts_memcpy_unaligned

  [Ivan Hu]
  * securebootcert: add variable AuditMode checking
  * securebootcert: add variable DeployedMode checking

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 21 Dec 2016 09:26:40 +0800

fwts (16.11.00-0ubuntu1) zesty; urgency=low

  [Colin Ian King]
  * ACPICA: Update to version 20160930
  * fwts-test: disassemble-0001: sync output to latest ACPICA changes


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Firmware Testing Team <fwts-devel@lists.ubuntu.com>
-Uploaders: Colin King <colin.king@ubuntu.com>, Keng-Yu Lin <kengyu@ubuntu.com>, Alex Hung <alex.hung@canonical.com>, Ivan Hu <ivan.hu@canonical.com>
+Uploaders: Colin King <colin.king@ubuntu.com>, Alex Hung <alex.hung@canonical.com>, Ivan Hu <ivan.hu@canonical.com>
 Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 7.0.50~), autoconf, automake, libtool, libjson0-dev | libjson-c-dev (>= 0.9), flex, bison, dh-autoreconf, dkms, libglib2.0-dev, pkg-config, libfdt-dev

## fwts 17.09.00

=== debian/changelog ===
fwts (17.09.00-0ubuntu1) artful; urgency=low

  * [Alex Hung]
  * lib: fwts_acpi_tables: add a new function to check Reserved field
  * acpi: replace checks for Reserved by fwts_acpi_reserved_zero_check
  * fwts-test: sync up with new fwts_acpi_reserved_zero_check
  * lib: replace spaces by tabs
  * lib: fwts_acpi_tables: add a new function to check reserved bits
  * acpi: replace checks for Flags by fwts_acpi_reserved_bits_check
  * fwts-test: sync up with new fwts_acpi_reserved_bits_check
  * acpi: replace checks for reserved bits by fwts_acpi_reserved_bits_check
  * fwts-test: sync up with new fwts_acpi_reserved_bits_check
  * acpi: spcr: check reserved values for parity and stop fields

  [Colin Ian King]
  * debian: copyright: fix spelling mistake: acpcia -> acpica
  * acpica: fix spelling mistake: acpcia -> acpica
  * ACPICA: Update to version 20170831
  * iASL: Fix incorrect memory allocation
  * lib: constify a couple of arrays
  * src/acpi/brightness: constify sys_path and return of brightness_get_path
  * acpi: method: constify arrays
  * acpica: constify array fwts_default_space_id_list
  * cmos: cmosdump: constify several char * arrays
  * bios: bios_info: constify array bios_info
  * bios: multiproc: constify array bus_types
  * dmi: dmicheck: constify array dmi_used_by_kernel_table
  * uefi: securebootcert: make array securebootcert_info_table const
  * uefi: uefidump: make array uefidump_info_table const
  * uefi: uefirtmisc: make arrays flag static const
  * uefi: uefirttime: constify static array dayofmonth
  * lib: fwts_firmware: make enums into a defined type
  * lib: fwts_framework: make several int fields into uint32_t
  * lib: fwts_framework: re-order and clean up fwts_framework fields
  * lib: fwts_log: make magic uint64_t to improve corruption checking
  * fwts_log: make line_number to a uint32_t type
  * acpica: constify bool parameter val in fwts_acpi_region_handler_called_set
  * lib: fwts_acpi_table: make indexes which and index uint32_t
  * lib: fwts-battery: make battery type a typedef'd enum
  * lib: fwts_battery: clean up battery interfaces
  * lib: fwts_button: make button counts and button number uint32_t
  * lib: fwts_checksum: object sizes should be size_t rather than int
  * lib: fwts_devicetree: constify a few function arguments
  * lib: fwts_formatting: make width parameter size_t
  * lib: fwts_wakealarm: make wakealarm times uint32_t
  * lib: fwts_battery: include inttypes.h for PRIu32 definition
  * lib: fwts_log_plaintext: include inttypes.h for PRIu32 definition
  * lib: fwts_log_xml: include inttypes.h for PRIu32 definition
  * acpi: battery: include stdint.h and inttypes.h
  * acpi: wakealarm: include stdint.h and inttypes.h

  [Ivan Hu]
  * efi_runtime: add resetsystem runtime service
  * securebootcert: remove the SignatureOwner on signature presence check

  [Jeffrey Hugo]
  * dmi: dmicheck: Fix Base Address Modifier checking
  * dmi: dmicheck: Add BMC Interface Type definitions from IPMI spec

  [Sakar Arora]
  * acpi: method: sbbr: set some methods as optional

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 27 Sep 2017 15:02:29 +0800

fwts (17.08.00-0ubuntu1) artful; urgency=low

  [Alex Hung]
  * auto-packager: mkpackage.sh: remove yakkety
  * dmicheck: fix dmi_reserved_bits_check function when size is 64
  * acpi: pmtt: fix typo from pmmt to pmtt
  * acpi: sdei: add ACPI SDEI test (mantis 1714)
  * fwts-test: Add regression test for SDEI
  * acpi: pcct: refactor subspace to individual functions
  * acpi: pcct: update PCCT table to ACPI 6.2 (mantis 1659 & 1755)
  * fwts-test: sync up PCCT tests with ACPI 6.2 changes
  * acpi: dppt: add ACPI DPPT test (mantis 1795)
  * acpi: pptt: add ACPI PPTT test
  * acpi: hmat: add ACPI HMAT test (mantis 1705)
  * fwts-test: Add regression test for HMAT
  * acpi: method: add _LSI test according to ACPI 6.2 (mantis 1721)
  * fwts-test: sync up tests for _LSI method
  * fwts-test: Add regression test for PPTT
  * acpi: rasf: add ACPI RASF test
  * fwts-test: Add regression test for RASF
  * acpi: sbbr: sync up with new SBBR tests
  * acpi: remove "Linux-read Firmware Developer Kit" from license header
  * doc: update contributors and date to the manual

  [Colin Ian King]
  * opal: fix build error on Ubuntu 12.04 i386 with gcc 4.6.3
  * lib: fwts_safe_mem: remove need to copy into a buffer
  * acpi: bert: add safe memory read check on mmap'd memory
  * acpi: hpet: add safe memory read check on mmap'd memory
  * acpi: mcfg: add safe memory read check on mmap'd PCI config memory
  * acpi: pcc: add safe memory read check on mmap'd PCC header
  * bios: pciirq: add safe memory read check on mmap'd pci irq region
  * bios: pnp: add safe memory read check on mmap'd memory region
  * dmi: dmicheck: fix incorrect safe memory read check on DMI mmap'd region
  * uefi: csm: add safe memory read check on mmap'd interrupt and option ROM
    regions
  * fwts_safe_mem: workaround longjmp clobber warnings
  * ACPICA: Update to version 20170728
  * lib: fwts_smbios: use fwts_safe_memcpy to read SMBIOS entry
  * lib: fwts_acpi_tables: re-work fwts_acpi_get_rsdp, less memory copies
  * lib: fwts_safe_mem: really force reads
  * lib: fwts_acpi_tables: unmap mem, fixes memory leak
  * acpi: xsdt: fix build error on 32 bit systems
  * acpica: fwts_acpica: fix linker issues on Fedora (LP: #1712572)

  [Jeffrey Hugo]
  * acpi: madt: Add support for ACPI 6.2

  [Mahesh Bireddy]
  * acpi: fadt: add SBBR compliance tests
  * acpi: madt: add SBBR compliance tests
  * acpi: spcr: add SBBR compliance tests
  * acpi: xsdt: add SBBR compliance tests

  [Rajat Goyal]
  * acpi: dbg2: add SBBR compliance tests
  * acpi: gtdt: add SBBR compliance tests
  * acpi: acpitables: add SBBR compliance tests

  [Sakar Arora]
  * dmi: dmicheck: add SBBR compliance tests
  * acpi: method: add SBBR compliance tests
  * acpi: rsdp: add SBBR compliance tests

  [Vinson Lee]
  * acpi: method: Fix error message.
  * README: Update JSON manipulation library name.


## fwts 18.03.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2017 Canonical, Ltd.
+# Copyright (C) 2012-2018 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License

=== debian/changelog ===
fwts (18.03.00-0ubuntu5) bionic; urgency=medium

  * Kernel 5.3 compatibility in ppc64el (LP: #1849570)
    - debian/patches/0009-efi_runtime-fix-gcc-warning-for-efi_runtime_reset_sy.patch
    - debian/patches/0010-efi_runtime-enable-KBUILD_MODPOST_WARN-y-to-workarou.patch

 -- Marcelo Henrique Cerri <marcelo.cerri@canonical.com>  Sat, 16 Nov 2019 06:44:35 -0300

fwts (18.03.00-0ubuntu4) bionic; urgency=medium

  [Colin Ian King]
  * efi_runtime: fix access_ok build issues on 5.0 kernels (LP: #1813059)
    - add Linux 5.0 compat fix to access_ok to fix dkms build issue

 -- Colin Ian King <colin.king@canonical.com>  Thu, 24 Jan 2019 09:25:11 +0000

fwts (18.03.00-0ubuntu3) bionic; urgency=medium

  * cpufreq: fix fwts_set paths (LP: #1786446)
    - upstream fwts commit b1593c337b44, corrects
      cpu path that had arguments swapped in cpufreq
      test.

 -- Colin Ian King <colin.king@canonical.com>  Fri, 10 Aug 2018 10:52:12 +0100

fwts (18.03.00-0ubuntu2) bionic; urgency=medium

  * enable PM debug messages for S3 + S4 (LP: #1772563)
    - kernels may have pm debug disabled, so force this on during S3/S4
      tests. Patches from upstream fwts

 -- Colin Ian King <colin.king@canonical.com>  Tue, 12 Jun 2018 14:20:11 +0100

fwts (18.03.00-0ubuntu1) bionic; urgency=medium

  [Alex Hung]
  * klog.json: change severity for AE_ALREADY_EXISTS errors
  * fwts-test: sync up with AE_ALREADY_EXISTS errors
  * dmi: dmicheck: add chassis type for Type 3

  [Colin Ian King]
  * ACPICA: Update to version 20180313

  [Deb McLemore]
  * olog:olog.json: Update OPAL skiboot errors to check on olog scan

  [Ivan Hu]
  * uefirtauthvar: remove test with EFI_VARIABLE_AUTHENTICATED_WRITE_ACCESS

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 21 Mar 2018 00:08:40 -0700

fwts (18.02.00-0ubuntu1) bionic; urgency=medium

  [Alex Hung]
  * acpi: acpiinfo: add acpi 6 to acpiinfo test
  * acpi: method: check one element in _TSD only for acpi 6.2+
  * acpi: spcr: update interface types based on DBG2
  * fwts-test: sync up with revision update in 9da9d5a5
  * acpi: method: allow _WAK to return an integer

  [Colin Ian King]
  * mkpackage.README: change urgency level to medium
  * lib: fwts_log: remove redundant initialization of ptr1
  * acpi: wmi: remove redundant initialization of 'info'
  * lib: fwts_log: remove redundant initialization of 'field'
  * lib: fwts_pipeio: remove variable status
  * lib: fwts_acpi_tables: remove redundant initialization to 'result'
  * ACPICA: Update to version 20180209
  * fwts-test/syntaxcheck-0001: sync up output with current ACPICA

  [Deb McLemore]
  * README: Add dependencies per Platform

  [Ivan Hu]
  * auto-packager: mkpackage.sh: remove zesty
  * uefirtvariable: modify both authenticated attributes setting test
  * uefirtvariable: add test for EFI_VARIABLE_AUTHENTICATED_WRITE_ACCESS
    attribute

  [Jeffrey Hugo]
  * acpi: fadt: Fix FACS checking
  * acpi: iort: Update revision checking

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 27 Feb 2018 10:53:06 +0800

fwts (18.01.00-0ubuntu1) bionic; urgency=low

  [Alex Hung]
  * acpi: LPIT: check for monotonically increasing UID
  * fwts-test: sync up with changes in lpit test

  [Colin Ian King]
  * Treewide: update copyright year to 2018
  * fwts-test: arg-help: sync up with copyright year changes
  * ACPICA: Update to version 20180105
  * acpica: fix linking issues when building non ACPI builds
  * lib: fwts-battery: use PRIu32 format specifier, fixes cppcheck warning
  * acpi: acpidump: move declaration to before statements, add blank lines
  * lib: fwts_safe_mem: don't perform void * pointer arithmetic, fix 32 bit end
  * lib: fwts_alloc: move 'pos' to a deeper scope, minor style change
  * opal: reserve_mem: remove redundant initialization of pointer p
  * opal: reserve_mem: remove unused variable 'i' and move scope of variable
    'value'
  * sbbr: rsdp: remove redundant initialization of boolean 'signature_pass'
  * acpi: madt: move scope of boolean 'passed'
  * acpi: pptt: move scope of index variable 'i'.
  * acpi: rasf: move scope of index variable 'i'
  * sbbr: acpitables: clean up code, move scope of some variables
  * acpi: erst: cast size to uint64_t to clean up static analysis warning
  * uefi: uefidump: clean up some static analysis warnings

  [Ivan Hu]
  * securebootcert: add checking read-only for the AuditMode and DeployedMode
  * securebootcert: move to UNSAFE category

 -- Ivan Hu <ivan.hu@ubuntu.com>  Thu, 25 Jan 2018 13:44:38 +0800

fwts (17.12.00-0ubuntu1) bionic; urgency=low

  [Alex Hung]
  * acpi: tpm2: update spec url

  [Colin Ian King]
  * trival: make read only const strings static
  * ACPICA: Update to version 20171215

  [Jeffrey Hugo]
  * acpi: bert: remove confusing warning

  [Ricardo Neri]
  * acpi: madt: only inspect Local APIC/x2APIC/SAPIC tables if enabled

  [Sakar Arora]
  * dmicheck: sbbr: make some SMBIOS structs optional
  * acpi: dbg2: sbbr: allow PL011 UART as a valid subtype
  * acpi: spcr: sbbr: IOAPIC is valid interrupt type
  * acpi: sbbr: relax a few test pass conditions

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 20 Dec 2017 16:23:05 +0800

fwts (17.11.00-0ubuntu1) bionic; urgency=low

  [Alex Hung]
  * lib: move and rename helper functions from method.c
  * acpi: devices: add a new test for ACPI AC adapter device
  * acpi: devices: add a new test for ACPI battery device
  * acpi: devices: add a new test for smart battery device
  * lib: move _CRS helper functions from method.c
  * acpi: devices: add a new test for acpi ec device
  * acpi: devices: print device name in acpi_ac test
  * acpi: devices: deiniit acpica when tests are skipped
  * acpi: devices: add new tests for power and sleep button devices
  * acpi: sync up _BIX test in method to acpi_battery tests
  * acpi: fadt: ACPI 6.2 explicitly states 64-bit supersedes 32-bit
  * acpi: madt: check GICD's system vector according to mantis 1819 (ACPI
    6.2a)


=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Firmware Testing Team <fwts-devel@lists.ubuntu.com>
 Uploaders: Colin King <colin.king@ubuntu.com>, Alex Hung <alex.hung@canonical.com>, Ivan Hu <ivan.hu@canonical.com>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 7.0.50~), autoconf, automake, libtool, libjson0-dev | libjson-c-dev (>= 0.9), flex, bison, dh-autoreconf, dkms, libglib2.0-dev, pkg-config, libfdt-dev
 
 Package: fwts
@@ -11,8 +11,8 @@
 Depends: libfwtsiasl1 (= ${binary:Version}), libfwtsacpica1 (= ${binary:Version}), libfwts1 (= ${binary:Version}), fwts-efi-runtime-dkms (= ${binary:Version}) [amd64] , ${shlibs:Depends}, ${misc:Depends}, pciutils, device-tree-compiler [ppc64el powerpc]
 Suggests: dmidecode
 Description: FirmWare Test Suite
- This is a firmware test suite that performs sanity checks on Intel/AMD 
- PC firmware. It is intended to identify BIOS and ACPI errors and 
+ This is a firmware test suite that performs sanity checks on system
+ firmware. It is intended to identify BIOS and ACPI errors and 
  if appropriate it will try to explain the errors and give advice to 
  help workaround or fix firmware bugs.  It is primarily intended to 
  be a Linux-centric firmware troubleshooting tool.
@@ -47,7 +47,7 @@
 Package: fwts-frontend
 Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x
 Priority: optional
-Depends: ${shlibs:Depends}, ${misc:Depends}, dialog, fwts
+Depends: ${misc:Depends}, dialog, fwts
 Description: Firmware Test Suite frontend interface
  This is a dialog based interface designed to provide an easy to use method
  to execute tests via Firmware Test Suite and is also used as the primary 
@@ -56,7 +56,7 @@
 Package: fwts-efi-runtime-dkms
 Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el
 Priority: optional
-Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
+Depends: ${misc:Depends}, dkms
 Description: Firmware Test Suite UEFI Runtime Service kernel driver
  This package provides the efi_runtime kernel driver in DKMS format,
  which is required for accessing UEFI Runtime Services.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

DEBVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
		| cut -d- -f1)

VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/[+-].*//' -e 's/~//g')

DKMS_SRC_DIR := $(CURDIR)/debian/fwts-efi-runtime-dkms/usr/src/fwts-efi-runtime-dkms-$(VERSION)

override_dh_auto_install:
	install -d $(DKMS_SRC_DIR)
	cp -a efi_runtime/* $(DKMS_SRC_DIR)
	dh_auto_install

override_dh_dkms:
	dh_dkms -V $(VERSION)

override_dh_auto_test:
ifneq ($(DEB_BUILD_ARCH),arm64)
	dh_auto_test $@
endif

%:
	dh $@ --with autoreconf,dkms

## fwts 18.09.00

=== debian/changelog ===
fwts (18.09.00-0ubuntu2) cosmic; urgency=medium

  [Colin Ian King]
  * efi_runtime: fix access_ok build issues on 5.0 kernels (LP: #1813059)
    - add Linux 5.0 compat fix to access_ok to fix dkms build issue

 -- Colin Ian King <colin.king@canonical.com>  Thu, 24 Jan 2019 09:25:11 +0000

fwts (18.09.00-0ubuntu1) cosmic; urgency=medium

  [Alex Hung]
  * dmicheck: fix incorrect boundary checks for various types
  * dmicheck: checks (Extended) Maximum Capacity for type 16

  [Anthony Wong]
  * snapcraft: add libbsd-dev to build-packages

  [Colin Ian King]
  * acpi: acpiinfo: use stdint print format specifiers for uint8_t values
  * acpi: nfit: minor code cleanup changes
  * acpi: acpitables: use PRIu32 format specifier for a uint32_t type
  * acpi: apicinstance: use correct format specifiers
  * acpi: checksum: print size_t values using %zd specifier
  * acpi: cstates: add whitespacing, use %d for int format specifiers
  * acpi: fadt: use inttype.h print format size specifiers
  * acpi/dmar: use PRIu8 specifier for uint8_t type
  * acpi/madt: use inttype.h print format size specifiers
  * acpi/method: use inttype.h print format size specifiers
  * sbbr/fadt: use inttype.h print format size specifiers
  * fwts-test: apicinstance: fix up incorrect hex values

  [Ge Song]
  * DMI: Fix the way to load SMBIOS 3.x tables via sysfs

  [Ivan Hu]
  * efi_runtime: re-enable the resetsystem runtime interface

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 12 Sep 2018 11:08:41 -0700

fwts (18.08.00-0ubuntu1) cosmic; urgency=medium

  [Alex Hung]
  * lib: dmicheck: replace defines by enum type
  * acpitables: remove redundant "OEM" from Creator ID field
  * acpitables: remove unnecessary new line character
  * src: remove unnecessary new line characters and trailing spaces
  * fwts-test: sync up with new line char and trailing space changes
  * acpi: wakealarm: remove failure messages for non-x86 arch
  * acpiinfo: update acpi version supported by kernel
  * ac_adapter: skip tests when no power supply exists
  * README: add a new required package since commit 3f151922fc13

  [Colin Ian King]
  * lib: fwts: Add abstracted pragma macros to push/pop state and disable
    warnings
  * fwts_uefi.h: replace _Pragmas with abstracted pragma macros
  * Wrap ACPI_ROOT_OBJECT with PRAGMA_NULL_PTR_MATH for clang builds
  * lib/src/fwts_acpi_tables: disable clang warning
  * lib: fwts_coreboot_cbmem.c: initialize all fields in array of structs
  * uefi: uefirtauthvar: don't logically or a constant operand.
  * dmi: dmicheck: remove redundant array fwts_dmi_chassis_type
  * ACPICA: Update to version 20180810
  * Add MIN, MAX and ARRAY_SIZE macros to fwts.h
  * fwts_coreboot_cbmem: fwts coding style changes, use off_t for addresses
  * lib: fwts_cpu: make found a boolean
  * lib: fwts_cpu: minor fwts coding style changes
  * lib: fwts_deviceytree: make a function argument const and a style change
  * lib: fwts_firmware: remove some empty lines
  * lib: fwts_iasl: remove a whitespace
  * lib: fwts_interactive: add sanity check on fileno, fix typo, tidy code
  * lib: fwts_ipmi: make fwts_ipmi_msg_id static, make some code style changes
  * lib: fwts_keymap: some minor fwts coding style changes
  * lib: fwts_list: some minor fwts coding style changes
  * lib: fwts_multiproc: remove whitespace
  * lib: fwts_olog: minor code style change on FILE pointers
  * lib: fwts_release: make some helper functions static
  * lib: fwts_scan_efi_systab: add empty line to match fwts coding style
  * fwts_coreboot_cbmem: fix off-by-one error on last char of buffer
  * lib: fwts_coreboot_cbmem: fix cbmem_console_addr check
  * lib: fwts_clog.c: replace space identations with tab
  * lib/src/fwts_acpi_tables: remove shadowed pointer ptr
  * lib: fwts_framework: ensure src pointer is const
  * fwts_framework: no need to pass tests_to_skip as it is locally scoped
  * lib: fwts_framework: argument 'arg' should not be const
  * lib: fwts_log: remove const arg in fwts_log_set_field_filter
  * lib: fwts_summary: remove redundant redefinition of fwts_summary_deinit
  * lib: fwts_safe_mem: add in missing constifications
  * lib: fwts_log_scan: rename function argument to avoid name shadowing
  * lib: fwts_stringextras: fix some missing constifictions
  * lib: fwts_text_list: fix up some const casting issues
  * lib: fwts_json.h: fix casting warning, add missing const
  * lib: fwts_coreboot_cbmen: fix missing const in cast
  * sbbr: acpitables: make function sbbr_search_acpi_tables static
  * acpi: crsdump: add in missing pointer constifications
  * acpi: ecdt: fix some missing pointer constifications
  * acpi: fadt: add in missing const to fix build warnings
  * sbbr: fadt: add in missing const to fix build warnings
  * acpi: method: make function method_test_CRS_return static
  * acpi: nfit: rename table to nfit_table to avoid name shadowing
  * acpi: wmi: add in missing const to fix build warnings
  * acpi: stao: add in missing const to fix build warnings
  * bios: mtrr make function multi_types_check static
  * opal: reserv_mem: add in missing const to fix build warnings
  * hotkey: rename list 'hotkeys' to avoid name shadowing
  * uefi: uefirtauthvar: rename argument attibutes to var_attributes
  * uefi: uefirtvariable: rename argument attibutes to var_attributes
  * coreboot: clog: rename list 'clog' to avoid name shadowing
  * lib: fwts_acpi_tables: unconstify data and don't strcpy ACPI table ids
  * Fix some strncpy/strcat gcc 8.2 warnings by using libbsd strlcpy/strlcat
  * snapcraft: add missing stage packages
  * snapcraft: remove libjson-c3 stage package, it is not required

  [Ivan Hu]
  * uefi: clean and check status with magic value ~0ULL (LP: #1784365)
  * uefi: uefivarinfo: add to UNSAFE category
  * acpi: gtdt: add checking the valid base physical address

 -- Alex Hung <alex.hung@ubuntu.com>  Wed, 22 Aug 2018 00:33:21 -0700

fwts (18.07.00-0ubuntu1) cosmic; urgency=medium

  [Alex Hung]


## fwts 19.03.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2018 Canonical, Ltd.
+# Copyright (C) 2012-2019 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License

=== debian/changelog ===
fwts (19.03.00-0ubuntu1) disco; urgency=medium

  [Alex Hung]
  * acpi: madt: Add support for ACPI 6.3
  * fwts-test: sync up with SMMU model updates
  * lib: fwts_acpi_tables: add a new function to check reserved values
  * lib: fwts_acpi_tables: rename fwts_acpi_subtable_length_check
  * srat: replace structure length checks by fwts_acpi_structure_length_check
  * acpi: refactor all table length checks to fwts_acpi_table_length_check
  * README: update installing fwts by "sudo make install"

  [Ard Biesheuvel]
  * acpi/fadt: reject 5.0 tables with ARM specific attributes set
  * acpi/iort: permit SMMU model values of 4 and 5
  * acpi/iort: fix error in SMMU node length check

  [Colin Ian King]
  * ACPICA: fix IASL building issues with gcc-9 and --as-needed linker option
  * fwts-test: sync up output to new IASL output defaults

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 20 Mar 2019 15:32:10 +0800

fwts (19.02.00-0ubuntu1) disco; urgency=medium

  [Alex Hung]
  * acpi: fix a typo in comment
  * klog.json: add an "IOAPIC .. not in IVRS" message
  * utilities: kernelscan: add AMD iommu for IVRS errors
  * acpi/method: check levels on full power and battery power
  * acpi: add address space types according to mantis 1965 (ACPI 6.2b)
  * acpi/pptt: check flags by revision (mantis 1870 for ACPI 6.2b)
  * acpi: pdtt: update flags defintion according to mantis 1867 (ACPI 6.3)
  * fwts-test: update regression test for PDTT
  * acpi/nfit: update memory mapping attributes (mantis 1873 for ACPI 6.3)
  * acpi/hmat: update for hmat revision 2 (mantis 1914 for ACPI 6.3)
  * fwts-test: update test for HMAT revision 2
  * acpi/madt: remove two reserved bytes (mantis 1934 for ACPI 6.3)
  * acpi/madt: update for Local APIC Flags (mantis 1948 for ACPI 6.3)
  * acpi/hmat: update System Locality Latency (mantis 1959 for ACPI 6.3)
  * fwts-test: update test for HMAT changes
  * acpi/method: add tests for NVDIMM control methods for ACPI 6.3
  * fwts-test: update method test for NVDIMM methods
  * acpiinfo: update ACPI and ACPICA versions
  * acpi/srat: add test for Generic Initiator (mantis 1904 for ACPI 6.3)

  [Colin Ian King]
  * efi_runtime: fix access_ok build issues on 5.0 kernels
  * fwts: fix up a handful of spelling mistakes
  * ACPICA: Update to version 20190215
  * fwts-test: update test output to be in sync with ACPICA 20190215
  * Makefiles: workaround address-of-packed-member warnings with gcc-9
  * acpica: utdecode: fix missing comma in array declaration AcpiGbl_GenericNotify

 -- Alex Hung <alex.hung@ubuntu.com>  Tue, 19 Feb 2019 10:32:21 +0100

fwts (19.01.00-0ubuntu1) disco; urgency=medium

  [Alex Hung]
  * mtrr: check memory type above 4GB on AMD platforms
  * dmi: dmicheck: remove redundant new lines
  * dsddump: add utility to dump _DSDD (Device Specific Data)
  * lib: fwts_ac_adapter: fix readdir(ac_power_dir) failing
  * lib: fwts_ac_adapter: fix failing to find AC directory

  [Colin Ian King]
  * Update copyright year to 2019
  * ACPICA: Update to version 20190108
  * mtrr: fix incorrect mask on amd_sys_conf
  * sbbr: fadt: clean up major/minor version checking
  * acpi/madt: clean up indentation issue, remove tab

  [Ivan Hu]
  * lib: fw_pm_method: move the sleep t_start time out of logind_on_signal (LP: #1809096)

 -- Alex Hung <alex.hung@ubuntu.com>  Tue, 15 Jan 2019 19:57:23 -0800

fwts (18.12.00-0ubuntu1) disco; urgency=medium

  [Alex Hung]
  * mtrr: allow uncached type for PCI prefetchable memory

  [Colin Ian King]
  * ACPICA: Update to version 20181213
  * fwts-test: disassemble-0001: sync output with updated ACPICA

  [Leif Lindholm]
  * lib: disable /dev/mem access on aarch64
  * dmicheck: drop unaligned memcpy
  * lib: drop fwts_memcpy_unaligned
  * dmicheck: use dmi_load_file in preference to fwts_mmap

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 19 Dec 2018 16:20:41 +0800

fwts (18.11.00-0ubuntu1) disco; urgency=medium

  [Alex Hung]
  * acpi: button: check fixed hardware & control method power buttons

  [Colin Ian King]
  * kernelscan: add -k option to specify klog json filename
  * ACPICA: Update to version 20181003
  * fwts-test: sync with ACPICA update to 20181003
  * README: update package dependency notes for RHEL
  * acpica: fix linker issues when building with ACPI disabled
  * ACPICA: Update to version 20181031
  * src/lib: add module probing helper functions
  * lib: fwts_efi_module: use the new module loading helper functions
  * lib/fwts_cpu: use new use the new module loading helper functions
  * snapcraft: update confinement and plugs
  * lib: fwts_coreboot_cbmem: don't use void * pointer arithmetic
  * lib: fwts_coreboot_cbmem: shift UL values rather than signed int values
  * lib: fwts_log: shift UL values rather than signed int values
  * acpi: syntaxcheck: rename syntaxcheck_table to syntaxcheck_single_table

  [Deb McLemore]
  * olog:olog.json: Update OPAL skiboot errors to check on olog scan

  [Ivan Hu]
  * dmicheck: fix Maximum Capacity checking range
  * ACPICA: Update to version 20180927
  * fwts-test: sync with ACPICA update to 20180927
  * mcfg: fix MMIO config space checking
  * madt: fix the Local APIC NMI processor UID checking
  * auto-packager: mkpackage.sh: add disco

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 14 Nov 2018 14:53:29 +0800
